@webUI
Feature: DeleteRulesFromAGroup

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "firewallGrp"
    And these users have been created with skeleton files:
      | username |
      | Alice    |

  Scenario: create, save and delete a single rule
    Given the user has placed a rule with the filter "File mimetype upload", the operator "is" and the value "text/plain" in the group named "firewallGrp"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the rule no "0" in the group named "firewallGrp"
    And the user saves the firewall rules
    Then it should be possible to upload a file with the mime-type "text/plain" using "any" dav path
    And it should be possible to upload a file with the mime-type "image/jpeg" using "any" dav path

  Scenario: create two rules, save and delete the last rule
    Given the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp"
    And the user has placed a rule with the filter "User Agent", the operator "is" and the value "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" in the group named "firewallGrp"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the rule no "1" in the group named "firewallGrp"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    But it should not be possible for user "Alice" to download the file "testimage.png" using "any" dav path

  Scenario: create two rules, save and delete the first rule
    Given the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp"
    And the user has placed a rule with the filter "User Agent", the operator "is" and the value "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" in the group named "firewallGrp"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the rule no "0" in the group named "firewallGrp"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "testimage.png" using "any" dav path
    But it should not be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path

  Scenario: create three rules, save and delete the middle rule
    Given the user has placed a rule with the filter "Request URL", the operator "ends with" and the value "png" in the group named "firewallGrp"
    And the user has placed a rule with the filter "User Agent", the operator "is not" and the value "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" in the group named "firewallGrp"
    And the user has placed a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "firewallGrp"
    And the user has saved the firewall rules
    When the user browses to the File Firewall settings page
    And the user deletes the rule no "1" in the group named "firewallGrp"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" with the "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
    And it should be possible for user "Alice" to download the file "lorem.txt" with the "my funny agent" user agent using "any" dav path
    And it should not be possible for user "Alice" to download the file "testimage.png" with the "my funny agent" user agent using "any" dav path
    But it should not be possible for user "Alice" to download the file "testimage.png" with the "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" user agent using "any" dav path
	