@webUI
Feature: MultipleFirewallGroups

  Background:
    Given using new dav path
    And the administrator has logged in using the webUI
    And user "%admin%" has created a "normal" tag with name "MyTagName"
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "firewallGrp1"
    And these users have been created with skeleton files:
      | username |
      | Alice    |

  Scenario: two groups with each one rule in it, where one evaluates to true and one to false
    When user "Alice" creates a public link share of file "lorem.txt" using the sharing API
    And the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "firewallGrp1"
    And the user creates an empty firewall rule group named "firewallGrp2"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +2 hour" in the group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should not be possible to download the file "lorem.txt" through the last created public link

  Scenario: two groups with each one rule in it, where one evaluates to true and one to false (reverse order)
    When user "Alice" creates a public link share of file "lorem.txt" using the sharing API
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +2 hour" in the group named "firewallGrp1"
    And the user creates an empty firewall rule group named "firewallGrp2"
    And the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should not be possible to download the file "lorem.txt" through the last created public link

  Scenario: two groups with each one rule in it, where both evaluate to true
    When user "Alice" creates a public link share of file "lorem.txt" using the sharing API
    And the user places a rule with the filter "Request Type", the operator "is not" and the value "WebDAV" in the group named "firewallGrp1"
    And the user creates an empty firewall rule group named "firewallGrp2"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now -1 hour,now +2 hour" in the group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should not be possible to download the file "lorem.txt" through the last created public link

  Scenario: two groups with each one rule in it, where both evaluate to false
    When user "Alice" creates a public link share of file "lorem.txt" using the sharing API
    And the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "firewallGrp1"
    And the user creates an empty firewall rule group named "firewallGrp2"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now +1 hour,now +2 hour" in the group named "firewallGrp2"
    And the user saves the firewall rules
    Then it should be possible to download the file "lorem.txt" through the last created public link

  Scenario: two groups with each two rules in it, all rules of one group evaluate to true
    When the user places a rule with the filter "Request Type", the operator "is not" and the value "WebDAV" in the group named "firewallGrp1"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now +1 hour,now +2 hour" in the group named "firewallGrp1"
    And the user creates an empty firewall rule group named "firewallGrp2"
    And the user places a rule with the filter "System file tag", the operator "is" and the value "MyTagName" in the group named "firewallGrp2"
    And the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "firewallGrp2"
    And the user saves the firewall rules
    And the user "Alice" tags the file "data.zip" with these tags
      | MyTagName |
    Then it should not be possible for user "Alice" to download the file "data.zip" using "any" dav path
    But it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
