@webUI
Feature: MultipleRulesPerFirewallGroup

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "multi-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |

  Scenario: two rules, where one evaluates to true and one to false
    When the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "multi-limiter"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now +1 hour,now +2 hour" in the group named "multi-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path

  Scenario: two rules, where one evaluates to true and one to false (reverse order)
    When the user places a rule with the filter "Request Time", the operator "between" and the value "now +1 hour,now +2 hour" in the group named "multi-limiter"
    And the user places a rule with the filter "Request Type", the operator "is" and the value "WebDAV" in the group named "multi-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path

  Scenario: two rules, where both evaluate to true
    Given user "Alice" has created a public link share of file "lorem.txt"
    When the user places a rule with the filter "Request Type", the operator "is" and the value "Public Share Link" in the group named "multi-limiter"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now,now +2 hour" in the group named "multi-limiter"
    And the user saves the firewall rules
    Then it should not be possible to download the file "lorem.txt" through the last created public link

  Scenario: two rules, where both evaluate to false
    When the user places a rule with the filter "Request Type", the operator "is not" and the value "Public Share Link" in the group named "multi-limiter"
    And the user places a rule with the filter "Request Time", the operator "between" and the value "now +1 hour,now +2 hour" in the group named "multi-limiter"
    And the user saves the firewall rules
    Then it should be possible for user "Alice" to download the file "lorem.txt" using "any" dav path
