@webUI
Feature: LimitFileAccessBasedOnUserDevice

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "userdevice-limiter"
    And these users have been created with skeleton files:
      | username |
      | Alice    |
    And user "Alice" has created a public link share of file "testimage.gif"

  Scenario Outline: prohibit file access for specific User Devices
    When the user places a rule with the filter "User Device", the operator "is" and the value <firewallSetting> in the group named "userdevice-limiter"
    And the user saves the firewall rules
    Then it should be possible to upload a file with the <allowedUserAgent> user agent using "any" dav path
    And it should be possible for user "Alice" to download the file "lorem.txt" with the <allowedUserAgent> user agent using "any" dav path
    And it should be possible for user "Alice" to view the preview of "lorem.txt" with the <allowedUserAgent> user agent
    And it should be possible to view the preview of "testimage.gif" through the last created public link with the <allowedUserAgent> user agent
    And it should be possible to download the file "testimage.gif" through the last created public link with the <allowedUserAgent> user agent
    But it should not be possible to upload a file with the <forbiddenUserAgent> user agent using "any" dav path
    And it should not be possible for user "Alice" to download the file "lorem.txt" with the <forbiddenUserAgent> user agent using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "lorem.txt" with the <forbiddenUserAgent> user agent
    And it should not be possible to view the preview of "testimage.gif" through the last created public link with the <forbiddenUserAgent> user agent
    And it should be possible to download the file "testimage.gif" through the last created public link with the <allowedUserAgent> user agent
    Examples:
      | firewallSetting           | allowedUserAgent                                                       | forbiddenUserAgent                                                     |
      | "Android Client"          | "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" | "Mozilla/5.0 (Android) ownCloud-android"                               |
      | "iOS Client"              | "Mozilla/5.0 (Android) ownCloud-android"                               | "iOS-ownCloud"                                                         |
      | "Desktop Client"          | "iOS-ownCloud"                                                         | "Mozilla/5.0 (Linux) mirall/2.3.3"                                     |
      | "Others (Browsers, etc.)" | "Mozilla/5.0 (Linux) mirall/2.3.3"                                     | "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" |

  Scenario Outline: prohibit file access for all User Devices except a specific one
    When the user places a rule with the filter "User Device", the operator "is not" and the value <firewallSetting> in the group named "userdevice-limiter"
    And the user saves the firewall rules
    Then it should be possible to upload a file with the <allowedUserAgent> user agent using "any" dav path
    And it should be possible for user "Alice" to download the file "lorem.txt" with the <allowedUserAgent> user agent using "any" dav path
    And it should be possible for user "Alice" to view the preview of "lorem.txt" with the <allowedUserAgent> user agent
    And it should be possible to view the preview of "testimage.gif" through the last created public link with the <allowedUserAgent> user agent
    And it should be possible to download the file "testimage.gif" through the last created public link with the <allowedUserAgent> user agent
    But it should not be possible to upload a file with the <forbiddenUserAgent> user agent using "any" dav path
    And it should not be possible for user "Alice" to download the file "lorem.txt" with the <forbiddenUserAgent> user agent using "any" dav path
    And it should not be possible for user "Alice" to view the preview of "lorem.txt" with the <forbiddenUserAgent> user agent
    And it should not be possible to view the preview of "testimage.gif" through the last created public link with the <forbiddenUserAgent> user agent
    And it should not be possible to download the file "testimage.gif" through the last created public link with the <forbiddenUserAgent> user agent
    Examples:
      | firewallSetting           | allowedUserAgent                                                       | forbiddenUserAgent                                                     |
      | "Android Client"          | "Mozilla/5.0 (Android) ownCloud-android"                               | "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" |
      | "iOS Client"              | "iOS-ownCloud"                                                         | "Mozilla/5.0 (Android) ownCloud-android"                               |
      | "Desktop Client"          | "Mozilla/5.0 (Linux) mirall/2.3.3"                                     | "iOS-ownCloud"                                                         |
      | "Others (Browsers, etc.)" | "Mozilla/5.0 (X11; Linux x86_64; rv:53.0) Gecko/20100101 Firefox/53.0" | "Mozilla/5.0 (Linux) mirall/2.3.3"                                     |
