@webUI
Feature: LimitUploadBasedOnRegExMimeType

  Background:
    Given the administrator has logged in using the webUI
    And the user has browsed to the File Firewall settings page
    And the user has created an empty firewall rule group named "mime-limiter"
    And user "Alice" has been created with default attributes and skeleton files
    And user "Alice" has created a public link share of file "simple-folder" with uploadwriteonly permissions

  Scenario: prohibit file upload for files with a mime type matching a regular expression
    When the user places a regular expression rule with the filter "File mimetype upload", the operator "is" and the value "text\/.*" in the group named "mime-limiter"
    And the user saves the firewall rules
    Then it should not be possible to upload a file with the mime-type "text/plain" using "any" dav path
    And it should not be possible to upload a file with the mime-type "text/vcard" using "any" dav path
    But it should be possible to upload a file with the mime-type "image/jpeg" using "any" dav path

  Scenario: prohibit file upload for files with a mime type not matching a regular expression
    When the user places a regular expression rule with the filter "File mimetype upload", the operator "is not" and the value "^[a-z]{5}\/mp4" in the group named "mime-limiter"
    And the user saves the firewall rules
    Then it should not be possible to upload a file with the mime-type "audio/ogg" using "any" dav path
    But it should be possible to upload a file with the mime-type "audio/mp4" using "any" dav path

  Scenario: prohibit file upload for files with a mime type matching a regular expression
    When the user places a regular expression rule with the filter "File mimetype upload", the operator "is" and the value "text\/.*" in the group named "mime-limiter"
    And the user saves the firewall rules
    Then it should not be possible to upload a file with the mime-type "text/plain" using "any" dav path on the last created public link
    And it should not be possible to upload a file with the mime-type "text/vcard" using "any" dav path on the last created public link
    But it should be possible to upload a file with the mime-type "image/jpeg" using "any" dav path on the last created public link

  Scenario: prohibit file upload for files with a mime type not matching a regular expression
    When the user places a regular expression rule with the filter "File mimetype upload", the operator "is not" and the value "^[a-z]{5}\/mp4" in the group named "mime-limiter"
    And the user saves the firewall rules
    Then it should not be possible to upload a file with the mime-type "audio/ogg" using "any" dav path on the last created public link
    But it should be possible to upload a file with the mime-type "audio/mp4" using "any" dav path on the last created public link
